#include <windows.h>
#include "rwlock.h"

CRWLock::CRWLock(void)
{
	InitializeCriticalSection(&m_lock);
	m_hSemaphore = CreateSemaphore(NULL, 1, 1, NULL);
	m_readersCount = 0;
}

CRWLock::~CRWLock(void)
{
	DeleteCriticalSection(&m_lock);
	CloseHandle(m_hSemaphore);
	m_readersCount = 0;
}

void CRWLock::ReadLock(void)
{
	Lock();

	if(!m_readersCount)
	{
		LockWriters();
	}
	m_readersCount++;

	Unlock();
}

void CRWLock::ReadUnlock(void)
{
	Lock();

	m_readersCount--;
	if(!m_readersCount)
	{
		UnlockWriters();
	}

	Unlock();
}

