#pragma once

class CRWLock
{
	CRITICAL_SECTION m_lock;
	HANDLE m_hSemaphore;

	int m_readersCount;
	
	void Lock()
		{
			EnterCriticalSection(&m_lock);
		}
	void Unlock()
		{
			LeaveCriticalSection(&m_lock);
		}
	void LockWriters(HANDLE hWaitToo = NULL)
		{
			if(!hWaitToo)
			{
				WaitForSingleObject(m_hSemaphore, INFINITE);
			} else
			{
				HANDLE arr[2];
				arr[0] = m_hSemaphore;
				arr[1] = hWaitToo;
				WaitForMultipleObjects(2, arr, FALSE, INFINITE);
			}
		}
	void UnlockWriters( void )
		{
			ReleaseSemaphore(m_hSemaphore, 1, NULL);
		}
public:
	CRWLock(void);
	~CRWLock(void);
	void ReadLock(void);
	void ReadUnlock(void);
	void WriteLock(HANDLE hWaitToo = NULL)
		{
			LockWriters(hWaitToo);
		}
	void WriteUnlock(void)
		{
			UnlockWriters();
		}
};
