// stdafx.h : include file for standard system include files,
//  or project specific include files that are used frequently, but
//      are changed infrequently
//

#if !defined(AFX_STDAFX_H__9F29EA6A_31EC_4854_B03C_C8643179B9BD__INCLUDED_)
#define AFX_STDAFX_H__9F29EA6A_31EC_4854_B03C_C8643179B9BD__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define ISOLATION_AWARE_ENABLED		1

// Insert your headers here
#define WIN32_LEAN_AND_MEAN		// Exclude rarely-used stuff from Windows headers

#include <windows.h>
#include <tlbpdk.h>
#include "arrays.h"
#include <ximage.h>
#include <boost/regex.hpp>
#include <commctrl.h>

// TODO: reference additional headers your program requires here

//extern HINSTANCE   g_hResInst;
extern HINSTANCE   g_hInst;
extern UINT        g_DllRefCount;

struct DATA
{
	BOOL		show;
	COLORREF	color;
};

struct ALIAS
{
	char* alias;
	char* path;
	char* workdir;
	WORD  hotKey;
	DWORD run;

	void Clear()
	{
		if(alias)		delete alias;
		alias		= NULL;
		if(workdir)		delete workdir;
		workdir		= NULL;
		if(path)		delete path;
		path		= NULL;
		hotKey = 0;
	}
};

struct SEARCH_ENGINE
{
	char*	name;
	char*	prefix;
	char*	url;
	char*	encoding;

	void Clear()
	{
		if(name)		delete name;
		name		= NULL;
		if(prefix)		delete prefix;
		prefix		= NULL;
		if(url)			delete url;
		url			= NULL;
		if(encoding)	delete encoding;
		encoding	= NULL;
	}
	void Set(SEARCH_ENGINE& dst)
	{
		Clear();
		name = new char[strlen(dst.name) + 1];
		strcpy(name, dst.name);
		prefix = new char[strlen(dst.prefix) + 1];
		strcpy(prefix, dst.prefix);
		url = new char[strlen(dst.url) + 1];
		strcpy(url, dst.url);
		encoding = new char[strlen(dst.encoding) + 1];
		strcpy(encoding, dst.encoding);
	}
};

struct ENCODING
{
	char name[64];
	char encoding[50];
};

extern void GetRelSkinPath(LPSTR fullSkinPath, LPSTR skinPath);
extern void GetFullSkinPath(LPSTR skinPath, LPSTR fullSkinPath);
extern void TrackMouseLeave(HWND hWnd, int remove);

#define FREE_CLEAR_STR(str) if(str) delete str; str = NULL;
#define MAKE_STR(str, cpstr) FREE_CLEAR_STR(str); if(cpstr) { str = new TCHAR[lstrlen(cpstr) + 1]; lstrcpy(str, cpstr); }

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_STDAFX_H__9F29EA6A_31EC_4854_B03C_C8643179B9BD__INCLUDED_)
