#pragma once
#include "ximage.h"
#include "treetabctl.h"

#define TREETAB_CLASS	TEXT("TLB_TREETAB_CLASS")
#define TABLABEL_CLASS	TEXT("TLB_TABLABEL_CLASS")

extern void RegisterTreeTabClass(HINSTANCE hInst);

//Messages
#define TTABM_ADDITEM			(WM_USER + 1)
#define TTABM_SETPARAMS			(WM_USER + 2)
#define TTABM_ACTIVATETAB		(WM_USER + 3)
#define TTABM_APPLY				(WM_USER + 4)
#define TTABM_GETCURRENT		(WM_USER + 5)
#define TTABM_REINITTABS		(WM_USER + 6)
#define TTABM_UPDATETEMPLATES	(WM_USER + 7)

#define TTABN_CHANGED		1

struct TTAB_OPTIONS
{
	RECT	rcPage;
	HWND	hWndPageLabel;
};

struct TTAB_PAGE
{
	UINT			pageID;
	HINSTANCE		hInstance;
	LPCDLGTEMPLATE	pResource;
	LPCTSTR			pszTitle;
	LPCTSTR			pszPageLabel;
	DLGPROC			pfnDlgProc;
	LPARAM			lParam;
	UINT			imgID;
};

//item states
#define TTAB_STATE_ACTIVE	0x001

struct _TTAB_PAGE
{
	UINT			pageID;
	HINSTANCE		hInstance;
	LPCDLGTEMPLATE	pResource;
	LPTSTR			pszTitle;
	LPCTSTR			pszPageLabel;
	DLGPROC			pfnDlgProc;
	LPARAM			lParam;
	CxImage*		img;
	UINT			state;
	RECT			rcItem;
	HWND			hWndPage;
};

class CTreeTabCtl
{
	HWND		m_hWnd;
	_TTAB_PAGE*	m_items;
	int			m_count;
	RECT		m_pagesRect;
	HWND		m_pagesLabel;

	SIZE		m_iconSize;
	SIZE		m_textSize;
	SIZE		m_itemSize;
public:
	CTreeTabCtl(void);
	virtual ~CTreeTabCtl(void);

	static LRESULT CALLBACK WndProc(HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam);
private:
	void OnCreate(void);
	void OnLButtonDown(int x, int y);
	void OnPaint(HDC hdc);
	void InitItems(TTAB_PAGE* items, int count);
	void RecalcLayout(void);
	void DrawItem(HDC hdc, _TTAB_PAGE* item, LPRECT rcItem);
	void ActivateItem(int idx);
	void ShowPage(_TTAB_PAGE* item);
	void SetParams(TTAB_OPTIONS* params);
	void Apply(void);
	void OnKeyDown(UINT vk);
};

class CTabLabel
{
	HWND	m_hWnd;
	HFONT	m_hFont;
public:
	CTabLabel();
	~CTabLabel();

	static LRESULT CALLBACK WndProc(HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam);
protected:
	void OnPaint(HDC hdc);
	void OnCreate();
};

