// memon.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "clsfact.h"
#include "cmdlinebtn.h"
#include "tlbhotkeyctl.h"
#include <commctrl.h>
#include "treetabctl.h"
#include "weblinkctl.h"


/**************************************************************************
   GUID stuff
**************************************************************************/

//this part is only done once
//if you need to use the GUID in another file, just include Guid.h
#pragma data_seg(".text")
#define INITGUID
#include <initguid.h>
#include <shlguid.h>
#include "Guid.h"
#pragma data_seg()

/**************************************************************************
   global variables
**************************************************************************/

//HINSTANCE   g_hResInst;
HINSTANCE   g_hInst;
UINT        g_DllRefCount;


/**************************************************************************

   DllMain

**************************************************************************/

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	switch(ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
		{
			g_hInst = (HINSTANCE) hModule;
//			g_hResInst = (HINSTANCE) hModule;
			InitCommonControls();
			LoadLibrary("Riched20.dll");

			RegisterTlbHotKeyClass(g_hInst);
			RegisterTreeTabClass(g_hInst);
			RegisterWebLinkClass(g_hInst);
		}
		break;
	case DLL_PROCESS_DETACH:
		/*if(g_hResInst && g_hResInst != g_hInst)
		{
			FreeLibrary(g_hResInst);
			g_hResInst = g_hInst;
		}*/
		break;
	}
   
	return TRUE;
}

/**************************************************************************

   DllRegisterServer

**************************************************************************/


STDAPI DllRegisterServer(void)
{
	if(RegisterPlugin(g_hInst, CLSID_CmdlineButton, "Command Line") != S_OK)
	{
		return SELFREG_E_CLASS;
	}
	return S_OK;
}

/**************************************************************************

   DllUnregisterServer

**************************************************************************/

STDAPI DllUnregisterServer(void)
{
	if(!UnregisterPlugin(CLSID_CmdlineButton))
	   return SELFREG_E_CLASS;

	return S_OK;
}


/**************************************************************************

   DllCanUnloadNow

**************************************************************************/

STDAPI DllCanUnloadNow(void)
{
	return (g_DllRefCount ? S_FALSE : S_OK);
}

/**************************************************************************

   DllGetClassObject

**************************************************************************/

STDAPI DllGetClassObject(  REFCLSID rclsid, 
                           REFIID riid, 
                           LPVOID *ppReturn)
{
	*ppReturn = NULL;

	//if we don't support this classid, return the proper error code
	if(!IsEqualCLSID(rclsid, CLSID_CmdlineButton))
	   return CLASS_E_CLASSNOTAVAILABLE;
   
	//create a CClassFactory object and check it for validity
	CClassFactory *pClassFactory = new CClassFactory(rclsid);
	if(NULL == pClassFactory)
	   return E_OUTOFMEMORY;
   
	//get the QueryInterface return for our return value
	HRESULT hResult = pClassFactory->QueryInterface(riid, ppReturn);

	//call Release to decement the ref count - creating the object set it to one 
	//and QueryInterface incremented it - since its being used externally (not by 
	//us), we only want the ref count to be 1
	pClassFactory->Release();

	//return the result from QueryInterface
	return hResult;
}


VOID CALLBACK TrackMouseTimerProc(HWND hWnd,UINT uMsg,UINT idEvent,DWORD dwTime) 
{
	RECT rect;
	POINT pt;

	GetWindowRect(hWnd, &rect);
	GetCursorPos(&pt);

	BOOL isMenu = FALSE;
	{
		TCHAR clsInfo[255];
		clsInfo[0] = 0;
		HWND ptWND = WindowFromPoint(pt);
		GetClassName(ptWND, clsInfo, 255);
		if(!lstrcmp(clsInfo, TEXT("#32768")))
		{
			isMenu = TRUE;
		}
	}

	if (!PtInRect(&rect, pt) || (WindowFromPoint(pt) != hWnd && !isMenu)) 
	{
		KillTimer(hWnd, idEvent);
		PostMessage(hWnd, WM_MOUSELEAVE, 0, 0);
	}
}


void TrackMouseLeave(HWND hWnd, int remove)
{
	if(remove)
	{
		KillTimer(hWnd, 100);
	} else
	{
		SetTimer(hWnd, 100, 50,(TIMERPROC)TrackMouseTimerProc);
	}
}
