// MemMonBtn.cpp: implementation of the CCmdlineBtn class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "cmdlinebtn.h"
#include "propsdlg.h"
#include <stdio.h>
#include <shobjidl.h>
#include <shlwapi.h>
#include <shellapi.h>
#include ".\cmdlinebtn.h"
#include <Mlang.h>
#include <Wininet.h>
#include <shlguid.h>
#include <richedit.h>
#include "tversion.h"
#include "cmdlinebtn.h"
#include "tlbhotkeyctl.h"
#include "treetabctl.h"
#include "weblinkctl.h"
#include <string>
#include <iostream>
#include <mmsystem.h>
#include "AboutDialog.h"

SEARCH_ENGINE defaultEngines[] = 
{
	{"Google",			"g", "http://www.google.com/search?q=%s&ie=utf-8&oe=utf-8", "utf-8"},
	{"AllTheWeb",		"a", "http://www.alltheweb.com/search?cat=web&charset=utf-8&query=%s", "utf-8"},
	{"Lycos",			"l", "http://search.lycos.com/main/setup.asp?query=%s", "iso-8859-1"},
	{"Amazon.com",		"z", "http://www.amazon.com/exec/obidos/external-search?index=blended&keyword=%s", "iso-8859-1"},
	{"SearchBoss",		"sb", "http://cluster.searchboss.com/cluster.asp?t=%s&p=2333", "iso-8859-1"},
	{"Ebay.com",		"e", "http://adfarm.mediaplex.com/ad/ck/711-1751-4022-31?loc=http%3A//service.bfast.com/bfast/click%3Fbfmid%3D37920209%26siteid%3D39488693%26bfpage%3D350x50_search_border%3FMfcISAPICommand%3DGetResult%26ht%3D1%26SortProperty%3DMetaEndSort%26query%3D%s%26ebaytag1%3Debayreg", "iso-8859-1"},
	{"DealTime",		"t", "http://www.dealtime.com/GS2/GS2StatReDirect/?bParent=on&nFormID=0&nParentFormID=0&linkin_id=3005961&uid=1738108048&keyword=%s&submit=Search", "iso-8859-1"},
	{"Download.com",	"w", "http://download.com.com/3120-20-0.html?qt=%s&tg=dl-2001&subj=windows&tag=search", "iso-8859-1"},
	{"Image",			"i", "http://www.alltheweb.com/search?cat=img&charset=utf-8&query=%s", "utf-8"},
	{"Video",			"v", "http://www.alltheweb.com/search?cat=vid&charset=utf-8&query=%s", "utf-8"},
	{"Mp3/Audio",		"m", "http://www.alltheweb.com/search?cat=mp3&charset=utf-8&query=%s", "utf-8"},
	{"Google groups",	"gr","http://groups.google.com/groups?q=%s&ie=utf-8&oe=utf-8", "utf-8"},
	{"News",			"n", "http://www.alltheweb.com/search?cat=news&charset=utf-8&query=%s", "utf-8"},
	{NULL, NULL, NULL, NULL}
};

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CCmdlineBtn::CCmdlineBtn()
{
	m_hResModule = g_hInst;
	m_curTab = PAGE_GENERAL;

	m_enableASList = TRUE;
	m_enableAUTOAPPEND = TRUE;
	m_hotKeys = NULL;
	m_hkCount = 0;
	m_autoHide = FALSE;
	m_skinPath[0] = 0;
	m_autoComplete = NULL;
	m_historySize = 50;
	m_oldProc = NULL;
	m_createdByHotKey = FALSE;
	sz = 200;

	m_align = 0;
	m_hotKey = 0;

	m_version = 7;
	m_ObjRefCount = 1;
	m_container = NULL;

	m_hWnd = NULL;
	m_buffSize = 500;
	m_insertPos = 0;
	m_text = (char*) malloc(sizeof(char) * m_buffSize);
	m_text[m_insertPos] = 0;
	m_strSize = 0;
	m_left = 0;

	m_fontName[0] = 0;
	m_fontBold = FALSE;
	m_fontItalic = FALSE;
	m_fontSize = 8;

	NONCLIENTMETRICS ncm;
 	ZeroMemory(&ncm, sizeof(ncm));
 	ncm.cbSize = sizeof(ncm);
 	SystemParametersInfo(SPI_GETNONCLIENTMETRICS, ncm.cbSize, &ncm, 0);

	m_font = CreateFontIndirect(&ncm.lfMessageFont);

	for(int i=0; defaultEngines[i].name; i++)
	{
		SEARCH_ENGINE engine;
		ZeroMemory(&engine, sizeof(engine));
		engine.Set(defaultEngines[i]);
		m_engines.Add(&engine);
	}

	m_skin.LoadDefault();

	m_history = new CCmdHistory;

	m_a_sortType = 1;
	m_a_sortCol  = 0;
	for(int i=0; i < 3; i++)
	{
		m_a_colOrder[i] = i;
	}
	m_a_colWidth[0] = 100;
	m_a_colWidth[1] = 50;
	m_a_colWidth[2] = 200;

	m_s_colWidth[0] = 200;
	m_s_colWidth[1] = 50;
	m_s_sortType = 1;
	m_s_sortCol  = 0;
	m_s_colOrder[0] = 0;
	m_s_colOrder[1] = 1;

	g_DllRefCount++;
}

CCmdlineBtn::~CCmdlineBtn()
{
	if(m_font)
	{
		DeleteObject(m_font);
	}
	if(m_hWnd)
	{
		RemoveProp(m_hWnd, TEXT("CCmdlineBtn"));
		PostMessage(m_hWnd, WM_USER + 1000, 0, 0);
	}
	if(m_text) free(m_text);
	m_text = NULL;

	for(int i=0; i < m_engines.GetCount(); i++)
	{
		m_engines[i].Clear();
	}
	for(int i=0; i < m_aliases.GetCount(); i++)
	{
		m_aliases[i].Clear();
	}
	m_engines.Clear();
	m_aliases.Clear();

	m_history->Release();
	m_history = NULL;
	if(m_autoComplete)
	{
		m_autoComplete->Release();
		m_autoComplete = NULL;
	}

	m_hotKey = 0;
	InitHotKeys();
	ClearHotkeys();
	delete m_hotKeys;

	g_DllRefCount--;
}


//////////////////////////////////////////////////////////////////////
// IUnknown methods
//////////////////////////////////////////////////////////////////////

STDMETHODIMP CCmdlineBtn::QueryInterface(REFIID riid, LPVOID *ppReturn)
{
	*ppReturn = NULL;

	//IUnknown
	if(IsEqualIID(riid, IID_ITlbButton))
	   {
	   *ppReturn = (ITlbButton*) this;
	   }
	if(IsEqualIID(riid, IID_IEnumString))
	   {
	   *ppReturn = (IEnumString*) this;
	   }
	if(IsEqualIID(riid, IID_IUnknown))
	   {
	   *ppReturn = (IUnknown*) ((ITlbButton*) this);
	   }

	if(*ppReturn)
	   {
	   (*(LPUNKNOWN*)ppReturn)->AddRef();
	   return S_OK;
	   }

	return E_NOINTERFACE;
}

STDMETHODIMP_(DWORD) CCmdlineBtn::AddRef()
{
	return ++m_ObjRefCount;
}

STDMETHODIMP_(DWORD) CCmdlineBtn::Release()
{
	if(--m_ObjRefCount == 0)
	{
		delete this;
		return 0;
	}
	return m_ObjRefCount;
}


//////////////////////////////////////////////////////////////////////
// ITlbButton methods
//////////////////////////////////////////////////////////////////////


// Load parameters for button
STDMETHODIMP CCmdlineBtn::Load(IStream *data)
{
	DWORD loadedVersion = 0;
	ULONG cbRead = 0;
	data->Read(&loadedVersion, sizeof(DWORD), &cbRead);
	data->Read(&sz, sizeof(sz), &cbRead);
	data->Read(&m_align, sizeof(m_align), &cbRead);
	data->Read(&m_hotKey, sizeof(m_hotKey), &cbRead);
	data->Read(m_skinPath, sizeof(m_skinPath), &cbRead);
	data->Read(&m_autoHide, sizeof(m_autoHide), &cbRead);
	if(loadedVersion >= 2)
	{
		data->Read(&m_enableASList, sizeof(m_enableASList), &cbRead);
		data->Read(&m_enableAUTOAPPEND, sizeof(m_enableAUTOAPPEND), &cbRead);
	}
	UINT sz = 0;
	if(loadedVersion >= 3)
	{
		data->Read(&m_a_sortType, sizeof(m_a_sortType), &cbRead);
		data->Read(&m_a_sortCol, sizeof(m_a_sortCol), &cbRead);
		data->Read(&sz, sizeof(sz), &cbRead);
		void* buf = malloc(sz);
		data->Read(buf, sz, &cbRead);
		memcpy(m_a_colWidth, buf, min(sz, sizeof(m_a_colWidth)));
		free(buf);
		data->Read(&sz, sizeof(sz), &cbRead);
		buf = malloc(sz);
		data->Read(buf, sz, &cbRead);
		memcpy(m_a_colOrder, buf, min(sz, sizeof(m_a_colOrder)));
		free(buf);

		data->Read(&m_s_sortType, sizeof(m_s_sortType), &cbRead);
		data->Read(&m_s_sortCol, sizeof(m_s_sortCol), &cbRead);
		data->Read(&sz, sizeof(sz), &cbRead);
		buf = malloc(sz);
		data->Read(buf, sz, &cbRead);
		memcpy(m_s_colWidth, buf, min(sz, sizeof(m_s_colWidth)));
		free(buf);
		data->Read(&sz, sizeof(sz), &cbRead);
		buf = malloc(sz);
		data->Read(buf, sz, &cbRead);
		memcpy(m_s_colOrder, buf, min(sz, sizeof(m_s_colOrder)));
		free(buf);
	}
	if(loadedVersion >= 4)
	{
		data->Read(&m_curTab, sizeof(m_curTab), &cbRead);
	}

	for(int i=0; i < m_engines.GetCount(); i++)
	{
		m_engines[i].Clear();
	}
	m_engines.Clear();

	sz = 0;
	data->Read(&sz, sizeof(sz), &cbRead);
    for(UINT i=0; i < sz; i++)
	{
		SEARCH_ENGINE engine;
		UINT strSZ = 0;
		
		data->Read(&strSZ, sizeof(strSZ), &cbRead);
		engine.encoding = new char[strSZ];
		data->Read(engine.encoding, strSZ, &cbRead);

		data->Read(&strSZ, sizeof(strSZ), &cbRead);
		engine.name = new char[strSZ];
		data->Read(engine.name, strSZ, &cbRead);

		data->Read(&strSZ, sizeof(strSZ), &cbRead);
		engine.prefix = new char[strSZ];
		data->Read(engine.prefix, strSZ, &cbRead);

		data->Read(&strSZ, sizeof(strSZ), &cbRead);
		engine.url = new char[strSZ];
		data->Read(engine.url, strSZ, &cbRead);

		m_engines.Add(&engine);
	}

	data->Read(&sz, sizeof(sz), &cbRead);
    for(UINT i=0; i < sz; i++)
	{
		ALIAS alias;
		ZeroMemory(&alias, sizeof(alias));
		UINT strSZ = 0;
		
		data->Read(&strSZ, sizeof(strSZ), &cbRead);
		alias.alias = new char[strSZ];
		data->Read(alias.alias, strSZ, &cbRead);

		data->Read(&strSZ, sizeof(strSZ), &cbRead);
		alias.path = new char[strSZ];
		data->Read(alias.path, strSZ, &cbRead);

		if(loadedVersion >= 1)
		{
			data->Read(&strSZ, sizeof(strSZ), &cbRead);
			if(strSZ)
			{
				alias.workdir = new char[strSZ];
				data->Read(alias.workdir, strSZ, &cbRead);
			} else
			{
				alias.workdir = NULL;
			}
		}

		data->Read(&alias.hotKey, sizeof(alias.hotKey), &cbRead);
		if(loadedVersion >= 6)
		{
			data->Read(&alias.run, sizeof(alias.run), &cbRead);
		} else
		{
			alias.run = SW_SHOWNORMAL;
		}
		m_aliases.Add(&alias);
	}

	data->Read(&sz, sizeof(sz), &cbRead);
    for(UINT i=0; i < sz; i++)
	{
		UINT strSZ = 0;
		data->Read(&strSZ, sizeof(strSZ), &cbRead);
		char* hist = new char[strSZ];
		data->Read(hist, strSZ, &cbRead);

		m_history->WriteLock();
		m_history->Add(&hist);
		m_history->WriteUnlock();
	}

	if(loadedVersion >= 5)
	{
		data->Read(&m_fontBold, sizeof(m_fontBold), &cbRead);
		data->Read(&m_fontItalic, sizeof(m_fontItalic), &cbRead);
		data->Read(&m_fontSize, sizeof(m_fontSize), &cbRead);
		data->Read(m_fontName, sizeof(m_fontName), &cbRead);
		if(loadedVersion >= 7)
		{
			data->Read(&m_historySize, sizeof(m_historySize), &cbRead);
		}
	}

	CreateCmdFont();
	m_skin.Load(m_skinPath);

	InitHotKeys();
	return S_OK;
}

// Save button parameters
STDMETHODIMP CCmdlineBtn::Save(IStream *data)
{
	ULONG cbWritten;
	data->Write(&m_version, sizeof(DWORD), &cbWritten);
	data->Write(&sz, sizeof(sz), &cbWritten);
	data->Write(&m_align, sizeof(m_align), &cbWritten);
	data->Write(&m_hotKey, sizeof(m_hotKey), &cbWritten);
	data->Write(m_skinPath, sizeof(m_skinPath), &cbWritten);
	data->Write(&m_autoHide, sizeof(m_autoHide), &cbWritten);
	data->Write(&m_enableASList, sizeof(m_enableASList), &cbWritten);
	data->Write(&m_enableAUTOAPPEND, sizeof(m_enableAUTOAPPEND), &cbWritten);

	data->Write(&m_a_sortType, sizeof(m_a_sortType), &cbWritten);
	data->Write(&m_a_sortCol, sizeof(m_a_sortCol), &cbWritten);
	UINT sz = sizeof(m_a_colWidth);
	data->Write(&sz, sizeof(sz), &cbWritten);
	data->Write(m_a_colWidth, sz, &cbWritten);
	sz = sizeof(m_a_colOrder);
	data->Write(&sz, sizeof(sz), &cbWritten);
	data->Write(m_a_colOrder, sz, &cbWritten);

	data->Write(&m_s_sortType, sizeof(m_s_sortType), &cbWritten);
	data->Write(&m_s_sortCol, sizeof(m_s_sortCol), &cbWritten);
	sz = sizeof(m_s_colWidth);
	data->Write(&sz, sizeof(sz), &cbWritten);
	data->Write(m_s_colWidth, sz, &cbWritten);
	sz = sizeof(m_s_colOrder);
	data->Write(&sz, sizeof(sz), &cbWritten);
	data->Write(m_s_colOrder, sz, &cbWritten);

	data->Write(&m_curTab, sizeof(m_curTab), &cbWritten);

	sz = m_engines.GetCount();
	data->Write(&sz, sizeof(sz), &cbWritten);
	for(int i=0; i < m_engines.GetCount(); i++)
	{
		sz = strlen(m_engines[i].encoding) + 1;
		data->Write(&sz, sizeof(sz), &cbWritten);
		data->Write(m_engines[i].encoding, sz, &cbWritten);

		sz = strlen(m_engines[i].name) + 1;
		data->Write(&sz, sizeof(sz), &cbWritten);
		data->Write(m_engines[i].name, sz, &cbWritten);

		sz = strlen(m_engines[i].prefix) + 1;
		data->Write(&sz, sizeof(sz), &cbWritten);
		data->Write(m_engines[i].prefix, sz, &cbWritten);

		sz = strlen(m_engines[i].url) + 1;
		data->Write(&sz, sizeof(sz), &cbWritten);
		data->Write(m_engines[i].url, sz, &cbWritten);
	}

	sz = m_aliases.GetCount();
	data->Write(&sz, sizeof(sz), &cbWritten);
	for(int i=0; i < m_aliases.GetCount(); i++)
	{
		sz = strlen(m_aliases[i].alias) + 1;
		data->Write(&sz, sizeof(sz), &cbWritten);
		data->Write(m_aliases[i].alias, sz, &cbWritten);

		sz = strlen(m_aliases[i].path) + 1;
		data->Write(&sz, sizeof(sz), &cbWritten);
		data->Write(m_aliases[i].path, sz, &cbWritten);

		if(m_aliases[i].workdir)
		{
			sz = strlen(m_aliases[i].workdir) + 1;
		} else
		{
			sz = 0;
		}
		data->Write(&sz, sizeof(sz), &cbWritten);
		if(sz)
		{
			data->Write(m_aliases[i].workdir, sz, &cbWritten);
		}

		data->Write(&m_aliases[i].hotKey, sizeof(m_aliases[i].hotKey), &cbWritten);
		data->Write(&m_aliases[i].run, sizeof(m_aliases[i].run), &cbWritten);
	}

	m_history->ReadLock();
	sz = m_history->GetCount();
	data->Write(&sz, sizeof(sz), &cbWritten);
	for(int i=0; i < m_history->GetCount(); i++)
	{
		sz = strlen((*m_history)[i]) + 1;
		data->Write(&sz, sizeof(sz), &cbWritten);
		data->Write((*m_history)[i], sz, &cbWritten);
	}
	m_history->ReadUnlock();

	data->Write(&m_fontBold, sizeof(m_fontBold), &cbWritten);
	data->Write(&m_fontItalic, sizeof(m_fontItalic), &cbWritten);
	data->Write(&m_fontSize, sizeof(m_fontSize), &cbWritten);
	data->Write(m_fontName, sizeof(m_fontName), &cbWritten);
	data->Write(&m_historySize, sizeof(m_historySize), &cbWritten);
	return S_OK;
}

// Sets button rectangle
STDMETHODIMP CCmdlineBtn::SetRect(RECT *rcItem)
{
	m_rc = rcItem[0];
	if(m_container)
	{
		if(!IsWindow(m_hWnd))
		{
			m_container->Invoke(CONTAINER_CMD_CREATEWNDREQUEST, 0, 0);
		} else
		{
			RECT rcEdit;
			GetEditRect(&m_rc, &rcEdit);
			MoveWindow(m_hWnd, rcEdit.left, rcEdit.top,
				rcEdit.right - rcEdit.left,
				rcEdit.bottom - rcEdit.top,
				TRUE);
		}
	}
	return S_OK;
}



// Set button container
// NOTE: do not call AddRef to store container pointer
STDMETHODIMP CCmdlineBtn::SetContainer(ITlbContainer *cont)
{
	m_container = cont;
	return S_OK;
}

STDMETHODIMP CCmdlineBtn::SetID(int btnID)
{
	m_ID = btnID;
	return S_OK;
}

STDMETHODIMP CCmdlineBtn::Draw(HANDLE hDC, RECT *rcItem)
{
	m_skin.Draw((HDC) hDC, rcItem);
	return S_OK;
}

STDMETHODIMP CCmdlineBtn::OnMouseOver(long keys, int x, int y)
{
	return S_OK;
}

STDMETHODIMP CCmdlineBtn::OnMouseLeave(long keys)
{
	return S_OK;
}

STDMETHODIMP CCmdlineBtn::OnMouseEnter(long keys, int x, int y)
{
	return S_OK;
}

STDMETHODIMP CCmdlineBtn::Create(IStream* data)
{
	if(m_container)
	{
		HWND hWndBand = m_container->GetBandWND();
		CCmdProperties dlg;
		dlg.m_tab = m_curTab;

		dlg.m_pageHistory.m_history = m_history;

		dlg.m_pageGeneral.sz					= sz;
		dlg.m_pageGeneral.m_align				= m_align;
		dlg.m_pageGeneral.m_hotKey				= m_hotKey;
		dlg.m_pageGeneral.m_autoHide			= m_autoHide;
		dlg.m_pageGeneral.m_historySize			= m_historySize;
		dlg.m_pageGeneral.m_enableASList		= m_enableASList;
		dlg.m_pageGeneral.m_enableAUTOAPPEND	= m_enableAUTOAPPEND;
		strcpy(dlg.m_pageGeneral.m_skinPath, m_skinPath);
		dlg.m_pageGeneral.m_fontBold			= m_fontBold;
		dlg.m_pageGeneral.m_fontItalic			= m_fontItalic;
		dlg.m_pageGeneral.m_fontSize			= m_fontSize;
		strcpy(dlg.m_pageGeneral.m_fontName, m_fontName);

		CpyAliases(dlg.m_pageAlias.m_aliases, m_aliases);
		dlg.m_pageAlias.m_sortCol = m_a_sortCol;
		dlg.m_pageAlias.m_sortType = m_a_sortType;
		memcpy(dlg.m_pageAlias.m_colOrder, m_a_colOrder, sizeof(m_a_colOrder));
		memcpy(dlg.m_pageAlias.m_colWidth, m_a_colWidth, sizeof(m_a_colWidth));

		CpyEngines(dlg.m_pageSearch.m_engines, m_engines);
		dlg.m_pageSearch.m_sortCol = m_s_sortCol;
		dlg.m_pageSearch.m_sortType = m_s_sortType;
		memcpy(dlg.m_pageSearch.m_colOrder, m_s_colOrder, sizeof(m_s_colOrder));
		memcpy(dlg.m_pageSearch.m_colWidth, m_s_colWidth, sizeof(m_s_colWidth));

		if(dlg.DoModal(hWndBand, m_hResModule) == IDOK)
		{
			m_curTab = dlg.m_tab;

			sz					= dlg.m_pageGeneral.sz;
			m_align				= dlg.m_pageGeneral.m_align;
			m_hotKey			= dlg.m_pageGeneral.m_hotKey;
			m_autoHide			= dlg.m_pageGeneral.m_autoHide;
			m_historySize		= dlg.m_pageGeneral.m_historySize;
			m_enableASList		= dlg.m_pageGeneral.m_enableASList;
			m_enableAUTOAPPEND	= dlg.m_pageGeneral.m_enableAUTOAPPEND;

			m_fontBold			= dlg.m_pageGeneral.m_fontBold;
			m_fontItalic		= dlg.m_pageGeneral.m_fontItalic;
			m_fontSize			= dlg.m_pageGeneral.m_fontSize;
			strcpy(m_fontName, dlg.m_pageGeneral.m_fontName);

			CpyAliases(m_aliases, dlg.m_pageAlias.m_aliases);
			m_a_sortCol			= dlg.m_pageAlias.m_sortCol;
			m_a_sortType		= dlg.m_pageAlias.m_sortType;
			memcpy(m_a_colOrder, dlg.m_pageAlias.m_colOrder, sizeof(m_a_colOrder));
			memcpy(m_a_colWidth, dlg.m_pageAlias.m_colWidth, sizeof(m_a_colWidth));
			
			CpyEngines(m_engines, dlg.m_pageSearch.m_engines);
			strcpy(m_skinPath, dlg.m_pageGeneral.m_skinPath);
			return Save(data);
		}
	}
	return S_FALSE;
}


STDMETHODIMP CCmdlineBtn::StateChanged(int state, int* needRedraw)
{
	*needRedraw = FALSE;
	return S_OK;
}

STDMETHODIMP CCmdlineBtn::GetDescription(char* szDescription)
{
	return S_FALSE;
}

STDMETHODIMP CCmdlineBtn::OnLButtonDown(long key, int x, int y)
{
	return S_FALSE;
}

STDMETHODIMP CCmdlineBtn::OnLButtonUp(long key, int x, int y)
{
	return S_FALSE;
}

STDMETHODIMP CCmdlineBtn::Run()
{
	return S_OK;
}



STDMETHODIMP CCmdlineBtn::DoAction(int action)
{
	switch(action)
	{
	case CTMS_PROPERTIES:
		if(m_container)
		{
			HWND hWndBand = m_container->GetBandWND();
			CCmdProperties dlg;
			dlg.m_tab = m_curTab;

			dlg.m_pageHistory.m_history = m_history;
			
			dlg.m_pageGeneral.sz					= sz;
			dlg.m_pageGeneral.m_align				= m_align;
			dlg.m_pageGeneral.m_hotKey				= m_hotKey;
			dlg.m_pageGeneral.m_autoHide			= m_autoHide;
			dlg.m_pageGeneral.m_historySize			= m_historySize;
			dlg.m_pageGeneral.m_enableASList		= m_enableASList;
			dlg.m_pageGeneral.m_enableAUTOAPPEND	= m_enableAUTOAPPEND;
			strcpy(dlg.m_pageGeneral.m_skinPath, m_skinPath);
			dlg.m_pageGeneral.m_fontBold			= m_fontBold;
			dlg.m_pageGeneral.m_fontItalic			= m_fontItalic;
			dlg.m_pageGeneral.m_fontSize			= m_fontSize;
			strcpy(dlg.m_pageGeneral.m_fontName, m_fontName);
			
			CpyAliases(dlg.m_pageAlias.m_aliases, m_aliases);
			dlg.m_pageAlias.m_sortCol = m_a_sortCol;
			dlg.m_pageAlias.m_sortType = m_a_sortType;
			memcpy(dlg.m_pageAlias.m_colOrder, m_a_colOrder, sizeof(m_a_colOrder));
			memcpy(dlg.m_pageAlias.m_colWidth, m_a_colWidth, sizeof(m_a_colWidth));
			
			CpyEngines(dlg.m_pageSearch.m_engines, m_engines);
			dlg.m_pageSearch.m_sortCol = m_s_sortCol;
			dlg.m_pageSearch.m_sortType = m_s_sortType;
			memcpy(dlg.m_pageSearch.m_colOrder, m_s_colOrder, sizeof(m_s_colOrder));
			memcpy(dlg.m_pageSearch.m_colWidth, m_s_colWidth, sizeof(m_s_colWidth));
			
			BOOL oldAutoHide = m_autoHide;
			m_autoHide = FALSE;
			ClearHotkeys();
			if(dlg.DoModal(hWndBand, m_hResModule) == IDOK)
			{
				m_curTab = dlg.m_tab;

				sz					= dlg.m_pageGeneral.sz;
				m_align				= dlg.m_pageGeneral.m_align;
				m_hotKey			= dlg.m_pageGeneral.m_hotKey;
				m_autoHide			= dlg.m_pageGeneral.m_autoHide;
				m_historySize		= dlg.m_pageGeneral.m_historySize;
				m_enableASList		= dlg.m_pageGeneral.m_enableASList;
				m_enableAUTOAPPEND	= dlg.m_pageGeneral.m_enableAUTOAPPEND;

				m_fontBold			= dlg.m_pageGeneral.m_fontBold;
				m_fontItalic		= dlg.m_pageGeneral.m_fontItalic;
				m_fontSize			= dlg.m_pageGeneral.m_fontSize;
				strcpy(m_fontName, dlg.m_pageGeneral.m_fontName);

				CpyAliases(m_aliases, dlg.m_pageAlias.m_aliases);
				m_a_sortCol			= dlg.m_pageAlias.m_sortCol;
				m_a_sortType		= dlg.m_pageAlias.m_sortType;
				memcpy(m_a_colOrder, dlg.m_pageAlias.m_colOrder, sizeof(m_a_colOrder));
				memcpy(m_a_colWidth, dlg.m_pageAlias.m_colWidth, sizeof(m_a_colWidth));
				
				CpyEngines(m_engines, dlg.m_pageSearch.m_engines);
				m_s_sortCol			= dlg.m_pageSearch.m_sortCol;
				m_s_sortType		= dlg.m_pageSearch.m_sortType;
				memcpy(m_s_colOrder, dlg.m_pageSearch.m_colOrder, sizeof(m_s_colOrder));
				memcpy(m_s_colWidth, dlg.m_pageSearch.m_colWidth, sizeof(m_s_colWidth));

				strcpy(m_skinPath, dlg.m_pageGeneral.m_skinPath);

				m_skin.Load(m_skinPath);

				CreateCmdFont();
				SetTextFont();

				SetAutoCompleteFlags();
				FixHistorySize();
				if(m_container)
				{
					m_container->UpdateButtonInfo(UPDATE_REDRAW | UPDATE_SIZE);
				}
				InitHotKeys();
				return m_container->SaveButton();
			} else
			{
				m_autoHide = oldAutoHide;
			}
			InitHotKeys();
		}
		break;
	case CTMS_ABOUT:
		if(m_container)
		{
			HWND hWndBand = m_container->GetBandWND();
			CAboutDialog dlg;
			dlg.DoModal(hWndBand, m_hResModule);
		}
	}
	return S_OK;
}

STDMETHODIMP_(int) CCmdlineBtn::QueryContextMenu(HMENU hMenu, int index, int cmdFirst, int cmdLast)
{
	return 0;
}

STDMETHODIMP CCmdlineBtn::InvokeCommand(int ID)
{
	return S_OK;
}


STDMETHODIMP CCmdlineBtn::SetLCID(DWORD dwLCID, HMODULE hResModule)
{
	if(!hResModule)
	{
		m_hResModule = g_hInst;
	} else
	{
		TCHAR flName[MAX_PATH];
		GetModuleFileName(hResModule, flName, MAX_PATH);
		VERSION flVersion;
		GetFileVersion(flName, flVersion);
		VERSION minVersion;
		minVersion.versionMS = MAKELONG(0, 3);
		minVersion.versionLS = 0;
		if(flVersion == minVersion)
		{
			m_hResModule = hResModule;
			RegisterTlbHotKeyClass(m_hResModule);
			RegisterTreeTabClass(m_hResModule);
			RegisterWebLinkClass(m_hResModule);
		} else
		{
			m_hResModule = g_hInst;
		}
	}
	return S_OK;
}

STDMETHODIMP CCmdlineBtn::GetIconLocation(LPSTR szLocation)
{
	return S_FALSE;
}

STDMETHODIMP CCmdlineBtn::SetIconLocation(LPCSTR szLocation)
{
	return S_FALSE;
}

STDMETHODIMP CCmdlineBtn::SetName(LPCSTR szName)
{
	return S_OK;
}

STDMETHODIMP CCmdlineBtn::GetButtonInfo(BUTTONINFO* btninfo)
{
	if(btninfo->dwMask & BTNINFO_MASK_ACTIONS)
	{
		btninfo->dwActions = CTMS_PROPERTIES | CTMS_ABOUT;
	}
	if(btninfo->dwMask & BTNINFO_MASK_MODEFLAG)
	{
		btninfo->dwModeFlags = BTN_FLAG_PLANE | BTN_FLAG_NOTIPS;
	}
	if(btninfo->dwMask & BTNINFO_MASK_SIZE ||
	   btninfo->dwMask & BTNINFO_MASK_ACTUALSIZE)
	{
		if(m_container)
		{
			SIZE szFont;
			HDC dc = GetDC(NULL);
			HFONT oldFont = (HFONT) SelectObject(dc, m_font);
			GetTextExtentPoint32(dc, "QWEtqf", strlen("QWEtqf"), &szFont);
			SelectObject(dc, oldFont);
			ReleaseDC(NULL, dc);

			CONTAINER_PARAMS params;
			params.cbSize = sizeof(CONTAINER_PARAMS);
			m_container->GetParams(&params);

			RECT rcMargins;
			m_skin.GetCmdMargins(&rcMargins);

			if(params.style & CTS_ISMENU)
			{
				btninfo->szBtnSize.cx = sz - 25 + rcMargins.left + rcMargins.right + 2;
				btninfo->szBtnSize.cy = szFont.cy + rcMargins.top + rcMargins.bottom + 1;
			} else
			{
				btninfo->szBtnSize.cx = sz - 25 + rcMargins.left + rcMargins.right + 2;
				btninfo->szBtnSize.cy = szFont.cy + rcMargins.top + rcMargins.bottom + 1;
			}
		}
	}
	if(btninfo->dwMask & BTNINFO_MASK_DESCRIPTION)
	{
		char* szDescription = (char*) btninfo->strData;
		szDescription[0] = 0;
	}
	return S_OK;
}

STDMETHODIMP CCmdlineBtn::Invoke(DWORD id, WPARAM wParam, LPARAM lParam)
{
	switch(id)
	{
	case TBTN_INVOKE_ONSHOW:
		ShowWindow(m_hWnd, SW_SHOW);
		break;
	case TBTN_INVOKE_ONHIDE:
		ShowWindow(m_hWnd, SW_HIDE);
		break;
	case TBTN_INVOKE_CREATEWND:
		Create((HWND) lParam);
		break;
	case TBTN_INVOKE_HOTKEYSCOUNT:
		{
			int* cnt = (int*) lParam;
			*cnt = m_hkCount + 1;
		}
		return S_OK;
	case TBTN_INVOKE_QUERYHOTKEY:
		{
			HKM_DATA* hk = (HKM_DATA*) lParam;
			if(!wParam)
			{
				hk->hotKeyID = wParam;
				hk->hotKey = m_hotKey;
				char name[260];
				sprintf(name, "Command Line (Activate)");
				MultiByteToWideChar(CP_ACP, 0, name, -1, hk->name, 260);
			} else
			{
				hk->hotKeyID = wParam;
				hk->hotKey = m_aliases[m_hotKeys[wParam - 1]].hotKey;
				char name[260];
				sprintf(name, "Command Line (%s)", m_aliases[m_hotKeys[wParam - 1]].alias);
				MultiByteToWideChar(CP_ACP, 0, name, -1, hk->name, 260);
			}
		}
		return S_OK;
	case TBTN_INVOKE_ONHOTKEY:
		if(m_container)
		{
			if(lParam == 0)
			{
				if(!m_hWnd)
				{
					m_createdByHotKey = TRUE;
				}
				m_container->Invoke(CONTAINER_CMD_SHOW, NULL, NULL);
				m_container->Invoke(CONTAINER_CMD_OPENWINDOW, NULL, (LPARAM) m_hWnd);
			} else
			{
				if(lParam - 1 < m_hkCount)
				{
					Execute(m_aliases[m_hotKeys[lParam - 1]].path, m_aliases[m_hotKeys[lParam - 1]].workdir);
				}
			}
		}
		return S_OK;
	}
	return S_FALSE;
}

LRESULT CALLBACK CCmdlineBtn::WndProc(HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam)
{
	CCmdlineBtn* pThis = NULL;
	if(IsWindow(hWnd))
	{
		pThis = (CCmdlineBtn*)GetProp(hWnd, TEXT("CCmdlineBtn"));
	}

	if(pThis || uMessage == WM_CREATE || uMessage == WM_USER + 1000)
	{
		switch (uMessage)
		{
		case WM_USER + 1000:
			DestroyWindow(hWnd);
			return 0;
		case WM_RBUTTONUP:
			if(pThis->m_container)
			{
				pThis->m_container->Invoke(CONTAINER_CMD_RBUTTONUP, NULL, NULL);
			}
			return 0;
		case WM_KEYDOWN:
			if(!pThis->OnKeyDown(wParam))
			{
				return 0;
			}
			break;
		case WM_KILLFOCUS:
			if(pThis->m_container)
			{
				if(pThis->m_autoHide)
				{
					pThis->m_container->Invoke(CONTAINER_CMD_HIDE, NULL, NULL);
				}
				pThis->m_container->Invoke(CONTAINER_CMD_KILLFOCUS, NULL, (LPARAM) wParam);
			}
			break;
		case WM_DESTROY:
			RemoveProp(hWnd, TEXT("CCmdlineBtn"));
			pThis->m_hWnd = NULL;
			if(pThis->m_autoComplete)
			{
				pThis->m_autoComplete->Release();
				pThis->m_autoComplete = NULL;
			}
			break;
		}
	}

	if(pThis && pThis->m_oldProc)
	{
		return CallWindowProc(pThis->m_oldProc, hWnd, uMessage, wParam, lParam);
	}
	return DefWindowProc(hWnd, uMessage, wParam, lParam);
}

void CCmdlineBtn::Create(HWND parent)
{
	if(!IsWindow(m_hWnd))
	{
		RECT rcEdit;
		GetEditRect(&m_rc, &rcEdit);
		m_hWnd = CreateWindowEx(WS_EX_TRANSPARENT, RICHEDIT_CLASS, "", WS_CHILD | WS_VISIBLE | ES_AUTOHSCROLL, 
			rcEdit.left, rcEdit.top,
			rcEdit.right - rcEdit.left,
			rcEdit.bottom - rcEdit.top,
			parent, NULL, g_hInst, (LPVOID) this);

		SetTextFont();
		CreateAutocomplete();

		SetProp(m_hWnd, TEXT("CCmdlineBtn"), (HANDLE) this);
		m_oldProc = (WNDPROC) SetWindowLong(m_hWnd, GWL_WNDPROC, (LONG) CCmdlineBtn::WndProc);
		if(m_createdByHotKey)
		{
			SetFocus(m_hWnd);
		}
	}
	m_createdByHotKey = FALSE;
}

LRESULT CCmdlineBtn::OnKeyDown(UINT key)
{
	switch(key)
	{
	case 0x56: //V
		if(GetKeyState(VK_CONTROL) & 0x8000)
		{
			SendMessage(m_hWnd, EM_PASTESPECIAL, CF_TEXT, NULL);
			return 0;
		}
		break;
	case 0x2D: //Insert
		if(GetKeyState(VK_SHIFT) & 0x8000)
		{
			SendMessage(m_hWnd, EM_PASTESPECIAL, CF_TEXT, NULL);
			return 0;
		}
		break;
	case VK_ESCAPE:
		SetWindowText(m_hWnd, "");
		return 0;
	case VK_RETURN:
		{
			int sz = SendMessage(m_hWnd, WM_GETTEXTLENGTH, 0, 0) + 1;
			char* m_text = new char[sz];
			GetWindowText(m_hWnd, m_text, sz);

			// fill history
			/*if(m_historySize)
			{
				int idx = -1;
				m_history->ReadLock();
				for(int i=0; i < m_history->GetCount(); i++)
				{
					if(!StrCmpI(m_text, (*m_history)[i]))
					{
						idx = i;
						break;
					}
				}
				m_history->ReadUnlock();
				if(idx < 0)
				{
					m_history->WriteLock();
					char* str = new char[sz];
					strcpy(str, m_text);
					m_history->Add(&str);
					m_history->WriteUnlock();
				} else
				{
					m_history->WriteLock();
					char* str = (*m_history)[idx];
					m_history->Delete(idx);
					m_history->Add(&str);
					m_history->WriteUnlock();
				}
				FixHistorySize();
			}*/

			char* workdir = NULL;
			DWORD runCmd = SW_SHOWNORMAL;
			//match aliases
			{
				int txtCMDLen = 0;
				while(m_text[txtCMDLen] && !isspace(m_text[txtCMDLen])) txtCMDLen++;
				for(int i=0; i < m_aliases.GetCount(); i++)
				{
					std::string str1("");
					str1.append(m_text, txtCMDLen);
					if(!lstrcmp(str1.c_str(), m_aliases[i].alias))
					{
						char* newTXT = ParseAlias(m_aliases[i].path, m_text);
						delete m_text;
						m_text = newTXT;
						//m_text = new char[strlen(m_aliases[i].path) + 1];
						//strcpy(m_text, m_aliases[i].path);
						workdir = m_aliases[i].workdir;
						runCmd = m_aliases[i].run;
						break;
					}
				}
			}
			//match search engines
			{
				for(int i=0; i < m_engines.GetCount(); i++)
				{
					int sz = strlen(m_engines[i].prefix);
					char* chr = new char[sz + 2];
					strcpy(chr, m_engines[i].prefix);
					strcat(chr, " ");
					if(!StrCmpNI(m_text, chr, sz + 1))
					{
						IMultiLanguage* ml = NULL;
						HRESULT hr = CoCreateInstance(CLSID_CMultiLanguage, NULL, CLSCTX_INPROC_SERVER, IID_IMultiLanguage, (LPVOID*) &ml);	

						if(hr == S_OK)
						{
							MIMECSETINFO csInfo;
							WCHAR wszCharSet[255];
							MultiByteToWideChar(CP_ACP, 0, m_engines[i].encoding, -1, wszCharSet, 255);
							BSTR bstrCharSet = SysAllocString(wszCharSet);
							ml->GetCharsetInfo(bstrCharSet, &csInfo);
							SysFreeString(bstrCharSet);

							DWORD pdwMode = 0;
							UINT dstSize = (strlen(m_text + sz + 1) + 1) * 3;
							LPBYTE strDst =  new BYTE[dstSize + 1];
							UINT defCP = GetACP();
							hr = ml->ConvertString(&pdwMode, defCP, csInfo.uiInternetEncoding, (BYTE*) (m_text + sz + 1), NULL, (BYTE*) strDst, &dstSize);
							if(hr != S_OK)
							{
								strcpy((char*) strDst, m_text + sz + 1);
								dstSize = strlen((char*) strDst);
							}
							char* urlText = new char[dstSize * 3 + 1];
							strDst[dstSize] = 0;
							int idx = 0;
							for(UINT j=0; j < dstSize; j++)
							{
								if(strDst[j] == '^' || 
								   strDst[j] == '&' ||
								   strDst[j] == '`' ||
								   strDst[j] == '{' ||
								   strDst[j] == '}' ||
								   strDst[j] == '|' ||
								   strDst[j] == ' ' ||
								   strDst[j] == '[' ||
								   strDst[j] == ']' ||
								   strDst[j] == '"' ||
								   strDst[j] == '>' ||
								   strDst[j] == '<' ||
								   strDst[j] == '\\' ||
								   strDst[j] >= 0x80)
								{
									sprintf(urlText + idx, "%%%0X", strDst[j]);
									idx += strlen(urlText + idx);
								} else
								{
									*(urlText + idx) = strDst[j];
									idx++;
									*(urlText + idx) = 0;
								}
							}
							delete m_text;
							m_text = new char[strlen(m_engines[i].url) + strlen(urlText) + 2];
							char* insPos = strstr(m_engines[i].url, "%s");
							if(insPos)
							{
								strncpy(m_text, m_engines[i].url, insPos - m_engines[i].url);
								m_text[insPos - m_engines[i].url] = 0;
								strcat(m_text, urlText);
								strcat(m_text, insPos + 2);
							} else
							{
								strcpy(m_text, m_engines[i].url);
							}
							//sprintf(m_text, m_engines[i].url, urlText);

							delete urlText;
							delete strDst;

							ml->Release();
						}
						
						delete chr;
						break;
					}
					delete chr;
				}
			}

			char* fileName = new char[strlen(m_text) + 1];
			strcpy(fileName, m_text);
			PathRemoveArgs(fileName);
			char* args = PathGetArgs(m_text);
			if((UINT) ShellExecute(m_hWnd, NULL, fileName, args, workdir, runCmd) > 32)
			{
				PlaySound(TEXT("MenuCommand"), NULL, SND_NODEFAULT | SND_ASYNC);
				if(!(GetKeyState(VK_CONTROL) & 0x8000))
				{
					int sz = SendMessage(m_hWnd, WM_GETTEXTLENGTH, 0, 0) + 1;
					char* m_text = new char[sz];
					GetWindowText(m_hWnd, m_text, sz);

					// fill history
					if(m_historySize)
					{
						int idx = -1;
						m_history->ReadLock();
						for(int i=0; i < m_history->GetCount(); i++)
						{
							if(!StrCmpI(m_text, (*m_history)[i]))
							{
								idx = i;
								break;
							}
						}
						m_history->ReadUnlock();
						if(idx < 0)
						{
							m_history->WriteLock();
							char* str = new char[sz];
							strcpy(str, m_text);
							m_history->Add(&str);
							m_history->WriteUnlock();
						} else
						{
							m_history->WriteLock();
							char* str = (*m_history)[idx];
							m_history->Delete(idx);
							m_history->Add(&str);
							m_history->WriteUnlock();
						}
						FixHistorySize();
						if(m_container)
						{
							m_container->SaveButton();
						}
					}
				}
			} else
			{
				PlaySound(TEXT(".Default"), NULL, SND_ASYNC);
			}
			delete m_text;
			delete fileName;
			SetWindowText(m_hWnd, "");
		}
		return 0;
	}
	return 1;
}

void CCmdlineBtn::InitHotKeys(void)
{
	if(m_container)
	{
		m_container->Invoke(CONTAINER_CMD_SETHOTKEY, m_hotKey, 0);
		m_hkCount = 0;
		for(int i=0; i < m_aliases.GetCount(); i++)
		{
			if(m_aliases[i].hotKey)
			{
				m_hkCount++;
			}
		}
		if(m_hkCount)
		{
			m_hotKeys = new int[m_hkCount];
			int idx = 0;
			for(int i=0; i < m_aliases.GetCount(); i++)
			{
				if(m_aliases[i].hotKey)
				{
					m_container->Invoke(CONTAINER_CMD_SETHOTKEY, m_aliases[i].hotKey, idx + 1);
					m_hotKeys[idx] = i;
					idx++;
				}
			}
		}
	}
}

void CCmdlineBtn::CpyAliases(CTArray<ALIAS>& dst, CTArray<ALIAS>& src)
{
	for(int i=0; i < dst.GetCount(); i++)
	{
		if(dst[i].alias) delete dst[i].alias;
		if(dst[i].path)  delete dst[i].path;
		if(dst[i].workdir)  delete dst[i].workdir;
	}
	dst.Clear();

	for(int i=0; i < src.GetCount(); i++)
	{
		ALIAS alias;
		alias.alias = new char[strlen(src[i].alias) + 1];
		strcpy(alias.alias, src[i].alias);
		alias.path = new char[strlen(src[i].path) + 1];
		strcpy(alias.path, src[i].path);
		if(src[i].workdir)
		{
			alias.workdir = new char[strlen(src[i].workdir) + 1];
			strcpy(alias.workdir, src[i].workdir);
		} else
		{
			alias.workdir = NULL;
		}
		alias.hotKey = src[i].hotKey;
		alias.run = src[i].run;
		dst.Add(&alias);
	}
}

void CCmdlineBtn::CpyEngines(CTArray<SEARCH_ENGINE>& dst, CTArray<SEARCH_ENGINE>& src)
{
	for(int i=0; i < dst.GetCount(); i++)
	{
		dst[i].Clear();
	}
	dst.Clear();

	for(int i=0; i < src.GetCount(); i++)
	{
		SEARCH_ENGINE eng;
		ZeroMemory(&eng, sizeof(eng));
		eng.Set(src[i]);
		dst.Add(&eng);
	}
}

void CCmdlineBtn::GetEditRect(LPRECT rcItem, LPRECT rcEdit)
{
	RECT rcMargins;
	m_skin.GetCmdMargins(&rcMargins);
	*rcEdit = *rcItem;
	rcEdit->left += rcMargins.left;
	rcEdit->top += rcMargins.top;
	rcEdit->right -= rcMargins.right;
	rcEdit->bottom -= rcMargins.bottom;

	//rcEdit->right += 25;
}


CCmdHistory::CCmdHistory()
{
	m_ObjRefCount = 1;
	m_enumIDX = -1;
}

CCmdHistory::~CCmdHistory()
{
	WriteLock();
	for(int i=0; i < GetCount(); i++)
	{
		delete (*this)[i];
	}
	WriteUnlock();
}

STDMETHODIMP CCmdHistory::QueryInterface(REFIID riid, LPVOID *ppReturn)
{
	*ppReturn = NULL;

	if(IsEqualIID(riid, IID_IEnumString))
	   {
	   *ppReturn = (IEnumString*) this;
	   }
	if(IsEqualIID(riid, IID_IUnknown))
	   {
	   *ppReturn = (IUnknown*) this;
	   }

	if(*ppReturn)
	   {
	   (*(LPUNKNOWN*)ppReturn)->AddRef();
	   return S_OK;
	   }

	return E_NOINTERFACE;
}

STDMETHODIMP_(DWORD) CCmdHistory::AddRef()
{
	return ++m_ObjRefCount;
}

STDMETHODIMP_(DWORD) CCmdHistory::Release()
{
	if(--m_ObjRefCount == 0)
	{
		delete this;
		return 0;
	}
	return m_ObjRefCount;
}

STDMETHODIMP CCmdHistory::Next(ULONG celt, LPOLESTR * rgelt, ULONG * pceltFetched)
{
	IMalloc* pMalloc;
	if(CoGetMalloc(1, &pMalloc) == S_OK)
	{
		ReadLock();
		if(pceltFetched) *pceltFetched = 0;
		for(ULONG i = 0; i < celt; i++)
		{
			m_enumIDX++;
			if(m_enumIDX >= GetCount())
			{
				ReadUnlock();
				return S_FALSE;
			}
			if(pceltFetched) (*pceltFetched)++;
			rgelt[i] = (LPOLESTR) pMalloc->Alloc((strlen((*this)[m_enumIDX]) + 1) * sizeof(WCHAR));
			MultiByteToWideChar(CP_ACP, 0, (*this)[m_enumIDX], -1, rgelt[i], strlen((*this)[m_enumIDX]) + 1);
		}
		ReadUnlock();
		pMalloc->Release();
		return S_OK;
	}
	return S_FALSE;
}

STDMETHODIMP CCmdHistory::Reset(void)
{
	m_enumIDX = -1;
	return S_OK;
}

STDMETHODIMP CCmdHistory::Skip(ULONG celt)
{
	m_enumIDX += celt;
	return S_OK;
}

STDMETHODIMP CCmdHistory::Clone(IEnumString ** ppenum)
{
	return S_FALSE;
}

void CCmdlineBtn::ClearHotkeys(void)
{
	if(m_container)
	{
		m_container->Invoke(CONTAINER_CMD_SETHOTKEY, 0, 0);
		if(m_hkCount)
		{
			for(int i=0; i < m_hkCount; i++)
			{
				m_container->Invoke(CONTAINER_CMD_SETHOTKEY, 0, i + 1);
			}
			delete m_hotKeys;
			m_hotKeys = NULL;
			m_hkCount = 0;
		}
	}
}

void CCmdlineBtn::Execute(char* cmd, char* workdir)
{
	char* fileName = new char[strlen(cmd) + 1];
	strcpy(fileName, cmd);
	PathRemoveArgs(fileName);
	char* args = PathGetArgs(cmd);
	ShellExecute(m_hWnd, NULL, fileName, args, workdir, SW_SHOWNORMAL);
	delete fileName;
	SetWindowText(m_hWnd, "");
}

void CCmdlineBtn::SetAutoCompleteFlags(void)
{
	if(!m_autoComplete) return;
	IAutoComplete2* ac2 = NULL;
	if(m_autoComplete->QueryInterface(IID_IAutoComplete2, (void**) &ac2) == S_OK)
	{
		UINT flags = ACO_UPDOWNKEYDROPSLIST;
		if(m_enableASList) flags |= ACO_AUTOSUGGEST;
		if(m_enableAUTOAPPEND) flags |= ACO_AUTOAPPEND;
		ac2->SetOptions(flags);
		ac2->Release();
	}
	if(m_historySize)
	{
		m_autoComplete->Enable(TRUE);
	} else
	{
		m_autoComplete->Enable(FALSE);
	}
}

void CCmdlineBtn::FixHistorySize(void)
{
	m_history->WriteLock();
	while(m_history->GetCount() > (int) m_historySize && m_history->GetCount())
	{
		delete (*m_history)[0];
		m_history->Delete(0);
	}
	m_history->WriteUnlock();
}

void CCmdlineBtn::StopHotkeys(void)
{
	if(m_hkCount)
	{
		if(m_container)
		{
			for(int i=0; i < m_hkCount; i++)
			{
				m_container->Invoke(CONTAINER_CMD_SETHOTKEY, 0, i + 1);
			}
		}
	}
}

char* CCmdlineBtn::ParseAlias(char* cmdLine, char* txt)
{
	char* args = PathGetArgs(txt);
	if(!args)
	{
		char* ret = new char[strlen(cmdLine) + 1];
		strcpy(ret, cmdLine);
		return ret;
	} else
	{
		std::string cmdln(args);
		std::string retSTR(cmdLine);

		boost::match_results<std::string::const_iterator> what;
		boost::regex e("(?:[[:space:]]?([^[:space:]]+)[[:space:]]?)|(?:(\"[[:print:]]*\"))");
		std::string::const_iterator start, end;
		start = cmdln.begin();
		end = cmdln.end();
		unsigned int flags = boost::match_default;
		UINT count = 0;
		int replaced = 0;
		while(boost::regex_search(start, end, what, e, flags))
		{
			count++;
			char strCNT[10];
			sprintf(strCNT, "%%%d", count);
			int pos = retSTR.find(strCNT);
			if(pos >= 0)
			{
				replaced++;
				retSTR.erase(pos, 2);
				std::string s;
				s = what[1];
				if(!s.length())
				{
					s = what[2];
				}
				retSTR.insert(pos, s);
			}

			start = what[0].second;
			flags |= boost::match_prev_avail;
			flags |= boost::match_not_bob;
		}
		if(!replaced)
		{
			retSTR.append(" ");
			retSTR.append(args);
		}
		char* ret = new char[retSTR.length() + 1];
		strcpy(ret, retSTR.c_str());
		return ret;
	}
	return NULL;
}


void CCmdlineBtn::CreateCmdFont(void)
{
	if(m_font)
	{
		DeleteObject(m_font);
		m_font = NULL;
	}
	if(m_fontName[0])
	{
		HDC hDC = GetDC(NULL);
		LOGFONT lf;
		ZeroMemory(&lf, sizeof(LOGFONT));
		strcpy(lf.lfFaceName, m_fontName);
		lf.lfHeight = -MulDiv(m_fontSize, GetDeviceCaps(hDC, LOGPIXELSY), 72);
		if(m_fontBold)
		{
			lf.lfWeight = FW_BOLD;
		} else
		{
			lf.lfWeight = FW_NORMAL;
		}
		lf.lfItalic = m_fontItalic;
		lf.lfCharSet = DEFAULT_CHARSET;
		lf.lfOutPrecision = OUT_DEFAULT_PRECIS;
		lf.lfQuality = DEFAULT_QUALITY;
		m_font = CreateFontIndirect(&lf);
		ReleaseDC(NULL, hDC);
	}
	if(!m_font) 
	{
		NONCLIENTMETRICS ncm;
		ZeroMemory(&ncm, sizeof(ncm));
		ncm.cbSize = sizeof(ncm);
		SystemParametersInfo(SPI_GETNONCLIENTMETRICS, ncm.cbSize, &ncm, 0);
		m_font = CreateFontIndirect(&ncm.lfMessageFont);
	}
}

void CCmdlineBtn::SetTextFont(void)
{
	if(m_hWnd)
	{
		SendMessage(m_hWnd, WM_SETFONT, (WPARAM) m_font, TRUE);
		CHARFORMAT chrFMT;
		ZeroMemory(&chrFMT, sizeof(chrFMT));
		chrFMT.cbSize = sizeof(CHARFORMAT);
		chrFMT.dwMask = CFM_COLOR;
		chrFMT.crTextColor = m_skin.GetTextColor();
		SendMessage(m_hWnd, EM_SETCHARFORMAT, (WPARAM) 0, (LPARAM) &chrFMT);
		CreateAutocomplete();
	}
}

void CCmdlineBtn::CreateAutocomplete(void)
{
	if(m_autoComplete)
	{
		if(m_hWnd)
		{
			m_autoComplete->Enable(FALSE);
		}
		ULONG ret = m_autoComplete->Release();
		m_autoComplete = NULL;
	}
	HRESULT hr = CoCreateInstance(CLSID_AutoComplete, NULL, CLSCTX_INPROC_SERVER, IID_IAutoComplete, (LPVOID*) &m_autoComplete);	
	if(hr == S_OK)
	{
		m_autoComplete->Init(m_hWnd, m_history, NULL, NULL);
		SetAutoCompleteFlags();
	}
}
