#pragma	  once

#define SZ_WIDTH	0x01
#define SZ_HEIGHT	0x02
#define SZ_MOVE_X	0x04
#define SZ_MOVE_Y	0x08

#define BEGIN_SIZING_MAP(cnt)  \
	int	__m_minCX;  \
	int	__m_minCY;  \
	int __m_cx;  \
	int __m_cy;  \
	 \
	void onSizing(WPARAM wParam, WPARAM lParam) \
	{ \
		LPRECT newRect = (LPRECT) lParam; \
		if(newRect->right - newRect->left < __m_minCX) \
		{ \
			switch(wParam) \
			{ \
			case WMSZ_BOTTOMLEFT: \
			case WMSZ_TOPLEFT: \
				newRect->left = newRect->right - __m_minCX; \
				break; \
			default: \
				newRect->right = newRect->left + __m_minCX; \
				break; \
			} \
		} \
		if(newRect->bottom - newRect->top < __m_minCY) \
		{ \
			switch(wParam) \
			{ \
			case WMSZ_TOPRIGHT: \
			case WMSZ_TOPLEFT: \
				newRect->top = newRect->bottom - __m_minCY; \
				break; \
			default: \
				newRect->bottom = newRect->top + __m_minCY; \
				break; \
			} \
		} \
	} \
 \
	void initSizing() \
	{ \
		RECT rcWindow; \
		GetClientRect(m_hWnd, &rcWindow); \
		__m_minCX = __m_cx = rcWindow.right - rcWindow.left; \
		__m_minCY = __m_cy = rcWindow.bottom - rcWindow.top; \
		 \
		int newCX = __m_cx; \
		int newCY = __m_cy; \
		DWORD cbSize = sizeof(newCX); \
		GetSavedWidth(&newCX); \
		GetSavedHeight(&newCY); \
		 \
		RECT rcDesk; \
		GetDesktopRect(&rcDesk, m_hWnd); \
		 \
		GetWindowRect(m_hWnd, &rcWindow); \
		rcWindow.right += newCX - __m_cx; \
		rcWindow.bottom += newCY - __m_cy; \
		 \
		if(rcWindow.bottom > rcDesk.bottom) \
		{ \
			rcWindow.top -= rcWindow.bottom - rcDesk.bottom; \
			rcWindow.bottom = rcDesk.bottom; \
		} \
		if(rcWindow.top < rcDesk.top) \
		{ \
			rcWindow.bottom += rcDesk.top - rcWindow.top; \
			rcWindow.top = rcDesk.top; \
		} \
		if(rcWindow.right > rcDesk.right) \
		{ \
			rcWindow.left -= rcWindow.right - rcDesk.right; \
			rcWindow.right = rcDesk.right; \
		} \
		if(rcWindow.left < rcDesk.left) \
		{ \
			rcWindow.right += rcDesk.left - rcWindow.left; \
			rcWindow.left = rcDesk.left; \
		} \
		SetWindowPos(m_hWnd, NULL, rcWindow.left, rcWindow.top, \
			rcWindow.right - rcWindow.left,\
			rcWindow.bottom - rcWindow.top,\
			SWP_NOACTIVATE | SWP_NOZORDER | SWP_NOREPOSITION);\
	} \
 \
	void onSize(int cx, int cy) \
	{ \
		HDWP hDWP = BeginDeferWindowPos(cnt);


#define SIZING_ITEM(ctlID, flags)  \
		{ \
			RECT rcItem; \
			GetWindowRect(GetDlgItem(m_hWnd, ctlID), &rcItem); \
			MapWindowPoints(NULL, m_hWnd, (LPPOINT) &rcItem, 2); \
			if((flags) & SZ_WIDTH) \
			{ \
				rcItem.right += cx - __m_cx; \
			} \
			if((flags) & SZ_HEIGHT) \
			{ \
				rcItem.bottom += cy - __m_cy; \
			} \
			if((flags) & SZ_MOVE_X) \
			{ \
				rcItem.left += cx - __m_cx; \
				rcItem.right += cx - __m_cx; \
			} \
			if((flags) & SZ_MOVE_Y) \
			{ \
				rcItem.top += cy - __m_cy; \
				rcItem.bottom += cy - __m_cy; \
			} \
			DeferWindowPos(hDWP, GetDlgItem(m_hWnd, ctlID), NULL,  \
				rcItem.left,  \
				rcItem.top,  \
				rcItem.right - rcItem.left, \
				rcItem.bottom - rcItem.top, SWP_NOACTIVATE | SWP_NOZORDER |SWP_NOREPOSITION); \
		}

#define END_SIZING_MAP  \
		EndDeferWindowPos(hDWP); \
		__m_cx = cx; \
		__m_cy = cy; \
	}
