// PropsDlg.cpp: implementation of the CPropsDlg class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "PropsDlg.h"
#include "resource.h"
#include <Commdlg.h>
#include <shlwapi.h>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CPropsDlg::CPropsDlg() : CTrueDialog(IDD_PROPS)
{

}

CPropsDlg::~CPropsDlg()
{

}

void CPropsDlg::OnInitDialog()
{
	SetDlgItemInt(m_hWnd, IDC_SZ, sz, FALSE);
	SetDlgItemText(m_hWnd, IDC_FILENAME, m_imgFile);

	SendDlgItemMessage(m_hWnd, IDC_ALIGN, CB_ADDSTRING, NULL, (LPARAM) "Center");
	SendDlgItemMessage(m_hWnd, IDC_ALIGN, CB_ADDSTRING, NULL, (LPARAM) "Left (top)");
	SendDlgItemMessage(m_hWnd, IDC_ALIGN, CB_ADDSTRING, NULL, (LPARAM) "Right (bottom)");
	SendDlgItemMessage(m_hWnd, IDC_ALIGN, CB_SETCURSEL, m_align, NULL);
}

BOOL CPropsDlg::OnEndDialog()
{
	sz = GetDlgItemInt(m_hWnd, IDC_SZ, NULL, FALSE);
	m_align = SendDlgItemMessage(m_hWnd, IDC_ALIGN, CB_GETCURSEL, 0, NULL);
	GetDlgItemText(m_hWnd, IDC_FILENAME, m_imgFile, MAX_PATH);
	return TRUE;
}


void CPropsDlg::OnCommand(DWORD itemID)
{
	switch(LOWORD(itemID))
	{
	case IDC_FILENAME:
		SetVis();
		break;
	case IDC_SELECTFILE:
		{
			TCHAR fileName[MAX_PATH];
			fileName[0] = 0;
			OPENFILENAME ofn;
			memset(&ofn, 0, sizeof(ofn));
			ofn.lStructSize = sizeof(ofn);
			ofn.hwndOwner = m_hWnd;
			ofn.hInstance = g_hInst;
			ofn.lpstrFilter = TEXT("PNG files\0*.png\0");
			ofn.lpstrCustomFilter = NULL;
			ofn.lpstrFile = fileName;
			ofn.nMaxFile = MAX_PATH;
			ofn.lpstrTitle = "Select picture for spacer";
			ofn.Flags = OFN_ENABLESIZING | OFN_FILEMUSTEXIST | OFN_LONGNAMES | OFN_PATHMUSTEXIST;
			if(GetOpenFileName(&ofn))
			{
				SetDlgItemText(m_hWnd, IDC_FILENAME, fileName);
				SetVis();
			}
		}
		break;
	}
}

void CPropsDlg::SetVis(void)
{
	char txt[MAX_PATH];
	GetDlgItemText(m_hWnd, IDC_FILENAME, txt, MAX_PATH);
	if(PathFileExists(txt))
	{
		EnableWindow(GetDlgItem(m_hWnd, IDC_SZ), FALSE);
		EnableWindow(GetDlgItem(m_hWnd, IDC_ALIGN), TRUE);
	} else
	{
		EnableWindow(GetDlgItem(m_hWnd, IDC_SZ), TRUE);
		EnableWindow(GetDlgItem(m_hWnd, IDC_ALIGN), FALSE);
	}
}
