// spacerbtn.h: interface for the CSpacerBtn class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MEMMONBTN_H__3C592E7C_85D8_4277_BC0D_A56DFD76A318__INCLUDED_)
#define AFX_MEMMONBTN_H__3C592E7C_85D8_4277_BC0D_A56DFD76A318__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ximage.h"

struct VALUE
{
	DWORD physTotal;
	DWORD physUsed;
	DWORD virtTotal;
	DWORD virtUsed;
	DWORD pageTotal;
	DWORD pageUsed;
};

class CSpacerBtn : public ITlbButton  
{
	DWORD m_version;
	RECT m_rc;
	DWORD m_ID;
	ITlbContainer* m_container;

    DWORD		sz;
	char		m_imgFile[MAX_PATH];
	CxImage*	m_img;
	UINT		m_align;
protected:
	DWORD m_ObjRefCount;
public:
	CSpacerBtn();
	virtual ~CSpacerBtn();

	//IUnknown methods
	STDMETHODIMP QueryInterface(REFIID, LPVOID*);
	STDMETHODIMP_(DWORD) AddRef();
	STDMETHODIMP_(DWORD) Release();

	//ITlbButton methods
    STDMETHODIMP Load(IStream *data);
    STDMETHODIMP Save(IStream *data);
    STDMETHODIMP SetRect(RECT *rcItem);
    STDMETHODIMP SetContainer(ITlbContainer *cont);
    STDMETHODIMP SetID(int btnID);
    STDMETHODIMP Draw(HANDLE hDC, RECT *rcItem);
    STDMETHODIMP OnMouseOver(long keys, int x, int y);
    STDMETHODIMP OnMouseLeave(long keys);
    STDMETHODIMP OnMouseEnter(long keys, int x, int y);
	STDMETHODIMP Create(IStream* data);
	STDMETHODIMP StateChanged(int state, int* needRedraw);
	STDMETHODIMP GetDescription(char* szDescription);
	STDMETHODIMP OnLButtonDown(long key, int x, int y);
	STDMETHODIMP OnLButtonUp(long key, int x, int y);
	STDMETHODIMP Run();
	STDMETHODIMP DoAction(int action);
	STDMETHODIMP SetName(LPCSTR szName);
	STDMETHODIMP_(int) QueryContextMenu(HMENU hMenu, int index, int cmdFirst, int cmdLast);
	STDMETHODIMP InvokeCommand(int ID);
	STDMETHODIMP SetLCID(DWORD dwLCID, HMODULE hResModule);
	STDMETHODIMP GetIconLocation(LPSTR szLocation);
	STDMETHODIMP SetIconLocation(LPCSTR szLocation);
	STDMETHODIMP GetButtonInfo(BUTTONINFO* btninfo);
	STDMETHODIMP Invoke(DWORD id, WPARAM wParam, LPARAM lParam);
private:
	void LoadImage(void);
};

#endif // !defined(AFX_MEMMONBTN_H__3C592E7C_85D8_4277_BC0D_A56DFD76A318__INCLUDED_)
