#include "tlbpdkcore.h"
#include "tlbpdklib.h"
#define STRSAFE_NO_DEPRECATE
#include <strsafe.h>

extern HINSTANCE   g_hResInst;
extern HINSTANCE   g_hInst;

CTlbButton::CTlbButton(void)
{
	m_ID = 0;
	m_iconLocation = NULL;
	m_container = NULL;
	m_hResModule = NULL;
	m_Name[0] = 0;
	m_container = NULL;
	g_DllRefCount++;
}

CTlbButton::~CTlbButton(void)
{
	FREE_CLEAR_STR(m_iconLocation);
	g_DllRefCount--;
}

int CTlbButton::GetTipsCount(void)
{
	return 1;
}

void CTlbButton::GetTipRect(int tipID, LPRECT rcTip)
{
	*rcTip = m_rc;
}

LPWSTR CTlbButton::GetTipText(int tipID)
{
	LPWSTR name = (LPWSTR) CoTaskMemAlloc((lstrlen(m_Name) + 1) * sizeof(WCHAR));
	lstrcpy(name, m_Name);
	return name;
}

void CTlbButton::SetRect(LPRECT rcItem)
{
	m_rc = rcItem[0];
}

void CTlbButton::GetIconLocation(LPWSTR szLocation)
{
	if(m_iconLocation && szLocation)
	{
		StringCchCopy(szLocation, MAX_PATH, m_iconLocation);
	}
}

BOOL CTlbButton::SetIconLocation(LPCWSTR szLocation)
{
	MAKE_STR(m_iconLocation, szLocation);
	if(m_container)
	{
		m_container->SaveButton();
		m_container->Redraw();
	}
	return TRUE;
}

void CTlbButton::SetName(LPCWSTR szName)
{
	StringCchCopy(m_Name, MAX_PATH,szName);
}

void CTlbButton::SetContainer(CTlbContainer* container)
{
	m_container = container;
}

BOOL CTlbButton::OnSetLCID(DWORD dwLCID, HMODULE hInstance)
{
	if(!hInstance)
	{
		m_hResModule = g_hInst;
	} else
	{
		m_hResModule = hInstance;
	}
	return TRUE;
}

 BOOL CTlbButton::isMenu() { return FALSE; }
 BOOL CTlbButton::FirstChildData(CHILDS_DATA* data) { return FALSE; }
 BOOL CTlbButton::NextChildData(CHILDS_DATA* data) { return FALSE; }
 BOOL CTlbButton::FreeChildData(CHILDS_DATA* data) { return FALSE; }
 BOOL CTlbButton::CreateChild(CREATE_CHILD_DATA* childData) { return FALSE; }
 HANDLE CTlbButton::GetChangesHandle() { return NULL; }
 void CTlbButton::PrepareChanges(HANDLE hChanges) {}
 void CTlbButton::CloseChangesHandle(HANDLE hChanges) {}
 UINT CTlbButton::ReadChanges() { return 0; }
 void CTlbButton::GetChildUID(LPWSTR uid) { }
 void CTlbButton::CompareButtons(COMPARE_BUTTONS_DATA* cpBtns) {}
 BOOL CTlbButton::QueryArrangeMenu(UINT idx, ARRANGE_MENU_DATA* qamData) { return FALSE; }
 void CTlbButton::GetSize(SIZE* sz, BOOL actual) {}
 UINT CTlbButton::GetModeFlags() { return 0; }
 BOOL CTlbButton::OnProperties() { return FALSE; }
 BOOL CTlbButton::OnRename() { return FALSE; }
 BOOL CTlbButton::OnAbout() { return FALSE; }
 BOOL CTlbButton::OnDelete() { return FALSE; }
 void CTlbButton::GetButtonName(LPWSTR name) 
 { 
	 lstrcpy(name, m_Name);
 }

void CTlbButton::OnShow() {}
void CTlbButton::OnHide() {}
void CTlbButton::CreateWnd(HWND hWndParent) {}

LPWSTR CTlbButton::GetTipCaption(int tipID) { return 0; }
UINT CTlbButton::GetSupportedActions() { return 0; }
void CTlbButton::GetButtonText(LPWSTR text) 
{
	lstrcpy(text, m_Name);
}
BOOL CTlbButton::SupportSortMenu() { return FALSE; }
HICON CTlbButton::GetTipIcon(int tipID) { return NULL; }

BOOL CTlbButton::Save(IStream *data) { return TRUE; }
BOOL CTlbButton::Load(IStream *data) {return TRUE; }
void CTlbButton::SetButtonID(UINT btnID) { m_ID = btnID; }
void CTlbButton::OnDraw(HDC hDC, LPRECT rcItem) {}
BOOL CTlbButton::OnMouseOver(long keys, int x, int y) { return FALSE; }
BOOL CTlbButton::OnMouseLeave(long keys) { return FALSE; }
BOOL CTlbButton::OnMouseEnter(long keys, int x, int y) { return FALSE; }
BOOL CTlbButton::OnCreate() { return TRUE; }
BOOL CTlbButton::OnStateChanged(int state, int* needRedraw) { return FALSE; }
BOOL CTlbButton::OnLButtonDown(long key, int x, int y) { return FALSE; }
BOOL CTlbButton::OnLButtonUp(long key, int x, int y) { return FALSE; }
BOOL CTlbButton::OnRun() { return FALSE; }
int  CTlbButton::QueryContextMenu(HMENU hMenu, int index, int cmdFirst, int cmdLast) { return 0; }
BOOL CTlbButton::OnContextMenuCommand(int ID) { return FALSE; }

BOOL CTlbButton::QueryClass(CLSID classID, LPVOID* lpClass)
{
	return FALSE;
}

void CTlbButton::OnHotkey(UINT hkID)
{
}

BOOL CTlbButton::GetHotKeyData(int idx, HOTKEY_DATA* hkData)
{
	return FALSE;
}

int	 CTlbButton::GetHotkeysCount()
{
	return 1;
}

UINT CTlbButton::GetMenuFlags()
{
	return 0;
}

int CTlbButton::GetTipsIconSize(int tipID)
{
	return 32;
}

void CTlbButton::DrawTipsIcon(HDC hDC, POINT pt, int tipID)
{
}

void CTlbButton::OnMeasureItem(WPARAM wParam, LPARAM lParam)
{
}

void CTlbButton::OnDrawItem(WPARAM wParam, LPARAM lParam)
{
}

void CTlbButton::tlbInsertMenuStringItem(	HMENU hMenu, 
											UINT ID, 
											UINT index, 
											LPTSTR str, 
											BOOL isDisabled,
											UINT checkStyle, 
											BOOL checkState, 
											HMENU hSubMenu)
{
	MENUITEMINFO mi;
	ZeroMemory(&mi, sizeof(mi));
	mi.cbSize = sizeof(MENUITEMINFO);

	if(m_container->tboShowCtxIcons())
	{
		mi.fMask = MIIM_ID | MIIM_TYPE;
		mi.fType = MFT_OWNERDRAW;
		mi.wID = ID;
	} else
	{
		mi.fMask = MIIM_TYPE | MIIM_ID;
		mi.fType = MFT_STRING;
		mi.dwTypeData = str;
		mi.cch = lstrlen(str);
		mi.wID = ID;
	}
	switch(checkStyle)
	{
	case CHK_STYLE_CHECK:
		mi.fMask |= MIIM_STATE;
		if(checkState)
		{
			mi.fState = MFS_CHECKED;
		} else
		{
			mi.fState = MFS_UNCHECKED;
		}
		break;
	case CHK_STYLE_RADIO:
		mi.fMask |= MIIM_STATE;
		mi.fType |= MFT_RADIOCHECK;
		if(checkState)
		{
			mi.fState = MFS_CHECKED;
		} else
		{
			mi.fState = MFS_UNCHECKED;
		}
		break;
	}
	if(hSubMenu)
	{
		mi.fMask |= MIIM_SUBMENU;
		mi.hSubMenu = hSubMenu;
	}
	if(isDisabled)
	{
		mi.fMask |= MIIM_STATE;
		mi.fState = MFS_DISABLED;
	}
	InsertMenuItem(hMenu, index, TRUE, &mi);
}
